﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI

	Private FlexGrid1 As FlexGrid
	Private Ev As Eval
	Private FlexGridLeft As FlexGrid
	Private FlexGridDown As FlexGrid
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.
Private Sub B4XPage_Appear
	FlexGridLeft.ColsWidth=Array As Int(70dip)
	FlexGridLeft.ColsName=Array As String("FIX")
	For i=1 To 100
		FlexGridLeft.AddRow(Array As Object("Fix" & i),False)
	Next
	FlexGridLeft.Invalidate
	
	FlexGridDown.AddRow(Array As Object("Totale","","0","","","0","0"),True)
	FlexGridDown.ColsWidth=Array As Int(100dip,50dip,50dip,120dip,90dip,150dip,130dip)
	
	Ev.Initialize(FlexGrid1)
	FlexGrid1.HeaderFont=xui.CreateDefaultFont(9)
	FlexGrid1.ColsName=Array As String("","N","On","Name","Img","Digit","List")
	FlexGrid1.ColsWidth=Array As Int(100dip,50dip,50dip,120dip,90dip,150dip,130dip)
	FlexGrid1.ColsType=Array As Int(FlexGrid1.TypeButton,FlexGrid1.TypeInt,FlexGrid1.TypeCheck,FlexGrid1.TypeString,FlexGrid1.TypeImage,FlexGrid1.TypeFloat,FlexGrid1.TypeList)
	FlexGrid1.ColsAlignment=Array As String("CENTER","CENTER","CENTER","LEFT","LEFT","RIGHT","CENTER")
	
	FlexGrid1.SetColCustomize(0,0xFF5BC17D,xui.Color_RGB(240,240,240),xui.CreateDefaultFont(14))
	
	Dim B As Boolean=False
	For i=1 To 10
		B=Not(B)
		FlexGrid1.AddRow(Array As Object("B" & i,i,B,"User " & i,Null,Rnd(50,1000)/10,"Jan,Feb,Mar,Apr,May,June,Jul"),True)
	Next

	
	FlexGrid1.SetCellvalue(0,0,100)
	FlexGrid1.SetCellvalue(0,4,xui.LoadBitmap(File.DirAssets,"b4a.png"))
	FlexGrid1.SetCellvalue(2,4,xui.LoadBitmap(File.DirAssets,"b4j.png")) 
	FlexGrid1.SetCellvalue(4,4,xui.LoadBitmap(File.DirAssets,"b4i.png"))
	
	FlexGrid1.SetCellCustomize(0,3,xui.Color_Black,xui.Color_Cyan,xui.CreateDefaultBoldFont(16))
	For i=11 To 100
		B=Not(B)
		If b Then
			FlexGrid1.AddRowCustomize(Array As Object("B" & i,i,B,"User " & i,Null,Rnd(50,1000)/10,"1,2,3,4,5"),xui.Color_Black,0xFFFFFFFF,xui.CreateDefaultFont(16),True)
		Else
			FlexGrid1.AddRowCustomize(Array As Object("B" & i,i,B,"User " & i,Null,Rnd(50,1000)/10,"a,b,c,d,e,f"),xui.Color_Black,0xFF44FF44,xui.CreateDefaultFont(16),True)
		End If
	Next

	Sleep(1000)
	FlexGrid1.SetCellValue(0,6,"Hi,Hallo,Good Bye,Good Night")
	FlexGrid1.SetCellListIndex(0,6,3)
	FlexGrid1.SetCellValue(0,2,False)
	FlexGrid1.SetCellValue(0,3,"Totale: " & Ev.Calculate("1+sum(0,1,9,1)"))
	Log(FlexGrid1.RowCount)
	
	Dim rw As Int = FlexGrid1.SearchInColumn("User 10",3,0,True,True)
	If rw>-1 Then FlexGrid1.SelectCell(rw,3,False)
	Log("Find :" & rw)
End Sub


Sub FlexGrid1_HeadClick(Index As Int)
	Log("Click Head Col: " & Index)
	FlexGrid1.Selectcol(Index)
End Sub

Sub FlexGrid1_CellClick(Row As Int, Col As Int)
	If Col=0 Then
		FlexGrid1.SelectRow(Row)
	Else
		Select FlexGrid1.GetTypeCol(Col)
			Case FlexGrid1.TypeCheck
				Dim B As Boolean = FlexGrid1.GetCellValue(Row,Col)
				Log("Cell content: " & B)

			Case FlexGrid1.TypeImage
				Dim Bm As B4XBitmap = FlexGrid1.GetCellValue(Row,Col)
				'Log("Cell content: " & Bm.IsInitialized)
			Case FlexGrid1.TypeInt
				Dim I As String = FlexGrid1.GetCellValue(Row,Col)
				Log("Cell content: " & I)
				FlexGrid1.EditCellonsite(Row,Col)
			Case FlexGrid1.TypeFloat
				Dim F As String = FlexGrid1.GetCellValue(Row,Col)
				Log("Cell content: " & F)
			Case FlexGrid1.TypeDouble
				Dim D As String = FlexGrid1.GetCellValue(Row,Col)
				Log("Cell content: " & D)
			Case FlexGrid1.TypeString
				Dim S As String = FlexGrid1.GetCellValue(Row,Col)
				Log("Cell content: " & S)
				FlexGrid1.EditCellonsite(Row,Col)
			Case FlexGrid1.TypeList
				Dim S As String = FlexGrid1.GetCellValue(Row,Col)
				Log($"Cell (${Row},${Col}) modified: "$ & S)
		End Select
	End If
End Sub

Sub FlexGrid1_CellLongClick(Row As Int, Col As Int)
	FlexGrid1.SelectCell(Row,Col,True)
End Sub

Sub FlexGrid1_Modified(Row As Int, Col As Int)
	If Col=1 Then
		Log(FlexGrid1.GetCellValue(Row,Col))
		FlexGrid1.SetCellValue(0,3,"Totale: " & Ev.Calculate("1+sum(0,1,9,1)"))
	End If
End Sub

Private Sub FlexGrid1_ScrollY(Position As Double)
	Log("y: " & Position)
	FlexGridLeft.ScrollY=Position
End Sub

Private Sub FlexGrid1_ScrollX(Position As Double)
	Log("X: " & Position)
	FlexGridDown.Scrollx=Position
End Sub

Private Sub FlexGridLeft_ScrollY(Position As Double)
	Log("y: " & Position)
	FlexGrid1.ScrollY=Position
End Sub

Private Sub FlexGridDown_ScrollX(Position As Double)
	Log("X: " & Position)
	FlexGrid1.Scrollx=Position
End Sub